{-# LANGUAGE ForeignFunctionInterface #-}
module HROOT.Core.TObjArray.FFI where
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TObjArray.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

foreign import ccall safe "HROOTCoreTObjArray.h TObjArray_Draw"
               c_tobjarray_draw :: Ptr RawTObjArray -> CString -> IO ()

foreign import ccall safe
               "HROOTCoreTObjArray.h TObjArray_FindObject" c_tobjarray_findobject
               :: Ptr RawTObjArray -> CString -> IO (Ptr RawTObject)

foreign import ccall safe "HROOTCoreTObjArray.h TObjArray_GetName"
               c_tobjarray_getname :: Ptr RawTObjArray -> IO CString

foreign import ccall safe "HROOTCoreTObjArray.h TObjArray_IsA"
               c_tobjarray_isa :: Ptr RawTObjArray -> IO (Ptr RawTClass)

foreign import ccall safe "HROOTCoreTObjArray.h TObjArray_Paint"
               c_tobjarray_paint :: Ptr RawTObjArray -> CString -> IO ()

foreign import ccall safe "HROOTCoreTObjArray.h TObjArray_printObj"
               c_tobjarray_printobj :: Ptr RawTObjArray -> CString -> IO ()

foreign import ccall safe "HROOTCoreTObjArray.h TObjArray_SaveAs"
               c_tobjarray_saveas ::
               Ptr RawTObjArray -> CString -> CString -> IO ()

foreign import ccall safe "HROOTCoreTObjArray.h TObjArray_Write"
               c_tobjarray_write ::
               Ptr RawTObjArray -> CString -> CInt -> CInt -> IO CInt

foreign import ccall safe "HROOTCoreTObjArray.h TObjArray_delete"
               c_tobjarray_delete :: Ptr RawTObjArray -> IO ()
